#include <math.h>
#if defined(WIN32)
#  include "glut.h"
#  include "glext.h"
extern PFNGLMULTITEXCOORD3DVPROC glMultiTexCoord3dv;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

#include "sphere.h"
#include "matrix.h"

#define PI 3.14159265358979323846

/*
** ɸϤ n ˡ٥ȥȤ֤ܶκɸϤؤѴ t 
*/
static void localToTangent(const double n[3], double t[16])
{
  double l = n[0] * n[0] + n[2] * n[2];
  double a = sqrt(l);

  /* ֤ܶΣؼ = (0, 1, 0)  n */
  if (a > 0) {
    t[ 0] = n[2] / a;
    t[ 8] = -n[0] / a;
  }
  else {
    t[ 0] = 0.0;
    t[ 8] = 0.0;
  }
  t[ 4] = 0.0;
  t[ 3] = 0.0;

  /* ֤ܶΣټ = ڼ (= n)  ؼ */
  t[ 1] = -n[1] * n[0];
  t[ 5] = l;
  t[ 9] = -n[1] * n[2];
  a = sqrt(t[ 1] * t[ 1] + t[ 5] * t[ 5] + t[ 9] * t[ 9]);
  if (a > 0) {
    t[ 1] /= a;
    t[ 5] /= a;
    t[ 9] /= a;
  }
  else {
    t[ 1] = 0.0;
    t[ 5] = 0.0;
    t[ 9] = 0.0;
  }
  t[ 7] = 0.0;

  /* ֤ܶΣڼ (= n) */
  t[ 2] = n[0];
  t[ 6] = n[1];
  t[10] = n[2];
  t[11] = 0.0;

  t[12] = 0.0;
  t[13] = 0.0;
  t[14] = 0.0;
  t[15] = 1.0;
}

/*
** ޥåפΥƥɸꤹ
** n: ˤˡ٥ȥ
** p: ΰ
** ll: ɸϤˤ
*/
static void normalizeTexCoord(double n[], double p[], double ll[])
{
  /* ֤ܶˤ */
  double lt[4] = { ll[0], ll[1], ll[2], ll[3] };
  /* ɸϤ֤ܶκɸϤؤѴ */
  double t[16];

  /* ʿԸǤʤи֤μºɸƤ */
  if (lt[3] != 0.0) {
    lt[0] = lt[0] / lt[3] - p[0];
    lt[1] = lt[1] / lt[3] - p[1];
    lt[2] = lt[2] / lt[3] - p[2];
  }

  /* ɸϤ֤ܶκɸϤؤѴ */
  localToTangent(n, t);
  
  /* ֤ܶˤ֤ */
  transform(lt, t, lt);
  
  /* ֤ܶˤ֤ƥɸꤹ */
  glMultiTexCoord3dv(GL_TEXTURE1, lt);
}

/*
** 
*/
void sphere(double radius, int slices, int stacks, const float l[])
{
  /* ɸϤˤ */
  double ll[4] = { l[0], l[1], l[2], l[3] };
  /* ǥӥ塼Ѵεչ */
  double m[16];
  
  /* ߤΥǥӥ塼Ѵεչ */
  glGetDoublev(GL_MODELVIEW_MATRIX, m);
  inverse(m, m);
  
  /* ɸϤˤ֤ */
  transform(ll, m, ll);
  
  /*  */
  for (int j = 0; j < stacks; ++j) {
    double t0 = (double)(j + 1) / (double)stacks;
    double t1 = (double)j / (double)stacks;
    double r0 = sin(PI * t0);
    double r1 = sin(PI * t1);
    double n[2][3], p[2][3];
    
    /* ˡñ̥٥ȥ y ʬ */
    n[0][1] = -cos(PI * t0);
    n[1][1] = -cos(PI * t1);
    
    /* ĺ y ɸ */
    p[0][1] = radius * n[0][1];
    p[1][1] = radius * n[1][1];
    
    /* ˡޥåפΥƥɸλ */
    t0 *= 4.0;
    t1 *= 4.0;
    
    glBegin(GL_QUAD_STRIP);
    for (int i = 0; i <= slices; ++i) {
      double s = (double)i / (double)slices;
      double a = -2.0 * PI * s;
      
      /* ˡñ̥٥ȥ x, z ʬ */
      n[0][0] = r0 * cos(a);
      n[0][2] = r0 * sin(a);
      n[1][0] = r1 * cos(a);
      n[1][2] = r1 * sin(a);
      
      /* ĺ x, z ɸ */
      p[0][0] = radius * n[0][0];
      p[0][2] = radius * n[0][2];
      p[1][0] = radius * n[1][0];
      p[1][2] = radius * n[1][2];
      
      /* ˡޥåפΥƥɸλ */
      s *= 8.0;
      
      /* ˡޥåפΥƥɸꤹ */
      glTexCoord2d(s, t0);
      
      /* ޥåפΥƥɸꤹ */
      normalizeTexCoord(n[0], p[0], ll);
      
      /* ĺ */
      glVertex3dv(p[0]);
      
      /* ˡޥåפΥƥɸꤹ */
      glTexCoord2d(s, t1);
      
      /* ޥåפΥƥɸꤹ */
      normalizeTexCoord(n[1], p[1], ll);
      
      /* ĺ */
      glVertex3dv(p[1]);
    }
    glEnd();
  }
}
